package com.persagy.dmp.report.service;

import com.persagy.common.criteria.JpaUtils;
import com.querydsl.jpa.impl.JPAQueryFactory;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections4.MapUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @author fengyanjie
 */
@Slf4j
@Service
public class TestService {

    @Autowired
    private JpaUtils jpaUtils;

    @Autowired
    JPAQueryFactory queryFactory;

    public List<Object[]> itemCode() {
        List<Object[]> result = new ArrayList<>();
        String sql = "select distinct code from dmp_alarm.alarm_item where valid = 1";
        List<Map<String, Object>> list = jpaUtils.queryList(sql);
        for (Map<String, Object> map : list) {
            result.add(new String[]{MapUtils.getString(map, "code")});
        }
        return result;
    }

    public List<Object[]> category() {
        List<Object[]> result = new ArrayList<>();
        String sql = "select distinct category from dmp_alarm.alarm_item where valid = 1";
        List<Map<String, Object>> list = jpaUtils.queryList(sql);
        for (Map<String, Object> map : list) {
            result.add(new String[]{MapUtils.getString(map, "category")});
        }
        return result;
    }

    public List<Object[]> classCodeObjType() {
        List<Object[]> result = new ArrayList<>();
        String sql = "select distinct code,obj_type from dmp_rwd.rwd_def_class";
        List<Map<String, Object>> list = jpaUtils.queryList(sql);
        for (Map<String, Object> map : list) {
            result.add(new String[]{MapUtils.getString(map, "code"), MapUtils.getString(map, "obj_type")});
        }
        return result;
    }
}
